/*******************************************************************************
 * Copyright (c) 2000, 2009 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    IBM Corporation - initial API and implementation
 *******************************************************************************/

#include "swt.h"
#include "xpcom_stats.h"

#ifdef NATIVE_STATS

int XPCOM_nativeFunctionCount = 225;
int XPCOM_nativeFunctionCallCount[225];
char * XPCOM_nativeFunctionNames[] = {
	"_1Call__I",
	"_1Call__IIIIII",
	"_1Call__III_3BII_3I",
	"_1JS_1EvaluateUCScriptForPrincipals",
	"_1NS_1GetComponentManager",
	"_1NS_1GetServiceManager",
	"_1NS_1InitXPCOM2",
	"_1NS_1NewLocalFile",
	"_1VtblCall__II",
	"_1VtblCall__IID",
	"_1VtblCall__IIF",
	"_1VtblCall__III",
	"_1VtblCall__IIII",
	"_1VtblCall__IIIII",
	"_1VtblCall__IIIIII",
	"_1VtblCall__IIIIIII",
	"_1VtblCall__IIIIIIII",
	"_1VtblCall__IIIIIIIIIIII",
	"_1VtblCall__IIIIIIIIIIIIIIISI",
	"_1VtblCall__IIIIIIIII_3I",
	"_1VtblCall__IIIIIIII_3C_3I_3I",
	"_1VtblCall__IIIIIII_3I",
	"_1VtblCall__IIIIIIJII",
	"_1VtblCall__IIIIII_3CIIIII_3I_3I",
	"_1VtblCall__IIIIII_3C_3BIIIII_3I_3I",
	"_1VtblCall__IIIIII_3C_3I_3I",
	"_1VtblCall__IIIIII_3I_3I",
	"_1VtblCall__IIIIII_3I_3I_3I",
	"_1VtblCall__IIIII_3B_3BI",
	"_1VtblCall__IIIII_3C",
	"_1VtblCall__IIIII_3I",
	"_1VtblCall__IIIII_3I_3I_3I",
	"_1VtblCall__IIIIJJJJ",
	"_1VtblCall__IIII_3B",
	"_1VtblCall__IIII_3BI",
	"_1VtblCall__IIII_3BII",
	"_1VtblCall__IIII_3B_3B",
	"_1VtblCall__IIII_3C",
	"_1VtblCall__IIII_3CIJI",
	"_1VtblCall__IIII_3CJJJ",
	"_1VtblCall__IIII_3C_3CI_3I",
	"_1VtblCall__IIII_3I",
	"_1VtblCall__IIII_3I_3I",
	"_1VtblCall__IIII_3J",
	"_1VtblCall__IIIJJ",
	"_1VtblCall__IIIJJJJJJ_3J",
	"_1VtblCall__IIILorg_eclipse_swt_internal_mozilla_nsID_2",
	"_1VtblCall__IIILorg_eclipse_swt_internal_mozilla_nsID_2II_3I",
	"_1VtblCall__IIILorg_eclipse_swt_internal_mozilla_nsID_2_3I",
	"_1VtblCall__III_3B",
	"_1VtblCall__III_3BI",
	"_1VtblCall__III_3BI_3I",
	"_1VtblCall__III_3BS",
	"_1VtblCall__III_3B_3B_3BI_3I",
	"_1VtblCall__III_3B_3C",
	"_1VtblCall__III_3B_3I",
	"_1VtblCall__III_3C",
	"_1VtblCall__III_3CI",
	"_1VtblCall__III_3C_3C",
	"_1VtblCall__III_3C_3CI_3C_3C_3C_3C_3I_3I",
	"_1VtblCall__III_3C_3CI_3I_3I_3I",
	"_1VtblCall__III_3C_3C_3C_3I",
	"_1VtblCall__III_3C_3C_3C_3I_3I",
	"_1VtblCall__III_3C_3C_3I",
	"_1VtblCall__III_3C_3C_3I_3C_3I_3I",
	"_1VtblCall__III_3C_3C_3I_3I_3C_3I_3I",
	"_1VtblCall__III_3C_3I",
	"_1VtblCall__III_3I",
	"_1VtblCall__III_3II",
	"_1VtblCall__III_3IJ",
	"_1VtblCall__III_3I_3I_3I",
	"_1VtblCall__III_3I_3I_3I_3I",
	"_1VtblCall__III_3I_3I_3J",
	"_1VtblCall__IIJ",
	"_1VtblCall__IIJI",
	"_1VtblCall__IIJIIJIIIIII",
	"_1VtblCall__IIJIIJIIIIIIIIISJ",
	"_1VtblCall__IIJIIJ_3I_3J",
	"_1VtblCall__IIJII_3I",
	"_1VtblCall__IIJIJII",
	"_1VtblCall__IIJIJJ_3I_3I_3I",
	"_1VtblCall__IIJIJ_3I_3I_3I",
	"_1VtblCall__IIJI_3J",
	"_1VtblCall__IIJJ",
	"_1VtblCall__IIJJI",
	"_1VtblCall__IIJJII",
	"_1VtblCall__IIJJIIII",
	"_1VtblCall__IIJJIJ_3C_3I_3I",
	"_1VtblCall__IIJJI_3C",
	"_1VtblCall__IIJJI_3I",
	"_1VtblCall__IIJJJ",
	"_1VtblCall__IIJJJI",
	"_1VtblCall__IIJJJI_3CJJIJI_3J_3J",
	"_1VtblCall__IIJJJI_3C_3BJJIJI_3J_3J",
	"_1VtblCall__IIJJJJIJ_3C_3I_3J",
	"_1VtblCall__IIJJJJJ",
	"_1VtblCall__IIJJJJJJ",
	"_1VtblCall__IIJJJJJJJ",
	"_1VtblCall__IIJJJJJ_3J",
	"_1VtblCall__IIJJJ_3B_3BJ",
	"_1VtblCall__IIJJJ_3I",
	"_1VtblCall__IIJJJ_3J",
	"_1VtblCall__IIJJ_3B",
	"_1VtblCall__IIJJ_3BJ",
	"_1VtblCall__IIJJ_3BJI",
	"_1VtblCall__IIJJ_3B_3B",
	"_1VtblCall__IIJJ_3CIJI",
	"_1VtblCall__IIJJ_3CJJJ",
	"_1VtblCall__IIJJ_3C_3CI_3J",
	"_1VtblCall__IIJJ_3I",
	"_1VtblCall__IIJJ_3I_3I",
	"_1VtblCall__IIJJ_3J",
	"_1VtblCall__IIJLorg_eclipse_swt_internal_mozilla_nsID_2",
	"_1VtblCall__IIJLorg_eclipse_swt_internal_mozilla_nsID_2JJ_3J",
	"_1VtblCall__IIJLorg_eclipse_swt_internal_mozilla_nsID_2_3J",
	"_1VtblCall__IIJ_3B",
	"_1VtblCall__IIJ_3BI",
	"_1VtblCall__IIJ_3BJ",
	"_1VtblCall__IIJ_3BJ_3J",
	"_1VtblCall__IIJ_3BS",
	"_1VtblCall__IIJ_3B_3B_3BJ_3J",
	"_1VtblCall__IIJ_3B_3C",
	"_1VtblCall__IIJ_3CI",
	"_1VtblCall__IIJ_3C_3C",
	"_1VtblCall__IIJ_3C_3CI_3C_3C_3C_3C_3I_3I",
	"_1VtblCall__IIJ_3C_3CI_3J_3I_3I",
	"_1VtblCall__IIJ_3C_3C_3C_3I",
	"_1VtblCall__IIJ_3C_3C_3C_3I_3I",
	"_1VtblCall__IIJ_3C_3C_3I",
	"_1VtblCall__IIJ_3C_3C_3J",
	"_1VtblCall__IIJ_3C_3C_3J_3C_3I_3I",
	"_1VtblCall__IIJ_3C_3C_3J_3J_3C_3I_3I",
	"_1VtblCall__IIJ_3C_3J",
	"_1VtblCall__IIJ_3I",
	"_1VtblCall__IIJ_3J",
	"_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2I",
	"_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2ILorg_eclipse_swt_internal_mozilla_nsID_2_3I",
	"_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2J",
	"_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2JLorg_eclipse_swt_internal_mozilla_nsID_2_3J",
	"_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2Lorg_eclipse_swt_internal_mozilla_nsID_2_3I",
	"_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2Lorg_eclipse_swt_internal_mozilla_nsID_2_3J",
	"_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2_3B_3BI",
	"_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2_3B_3BI_3B_3B",
	"_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2_3B_3BJ",
	"_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2_3B_3BJ_3B_3B",
	"_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2_3I",
	"_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2_3J",
	"_1VtblCall__IISIII",
	"_1VtblCall__IISJIJ",
	"_1VtblCall__II_3B",
	"_1VtblCall__II_3BI",
	"_1VtblCall__II_3BII_3I_3I",
	"_1VtblCall__II_3BIJ_3J_3I",
	"_1VtblCall__II_3BILorg_eclipse_swt_internal_mozilla_nsID_2_3I",
	"_1VtblCall__II_3BI_3I",
	"_1VtblCall__II_3BI_3I_3I",
	"_1VtblCall__II_3BI_3J_3I",
	"_1VtblCall__II_3BJ",
	"_1VtblCall__II_3BJLorg_eclipse_swt_internal_mozilla_nsID_2_3J",
	"_1VtblCall__II_3BJ_3I",
	"_1VtblCall__II_3BLorg_eclipse_swt_internal_mozilla_nsID_2I",
	"_1VtblCall__II_3BLorg_eclipse_swt_internal_mozilla_nsID_2J",
	"_1VtblCall__II_3BLorg_eclipse_swt_internal_mozilla_nsID_2_3I",
	"_1VtblCall__II_3BLorg_eclipse_swt_internal_mozilla_nsID_2_3J",
	"_1VtblCall__II_3B_3B",
	"_1VtblCall__II_3B_3BI",
	"_1VtblCall__II_3B_3B_3BII_3I",
	"_1VtblCall__II_3B_3B_3BII_3J",
	"_1VtblCall__II_3B_3B_3I",
	"_1VtblCall__II_3B_3B_3J",
	"_1VtblCall__II_3B_3I",
	"_1VtblCall__II_3B_3I_3I",
	"_1VtblCall__II_3B_3I_3J",
	"_1VtblCall__II_3B_3J",
	"_1VtblCall__II_3B_3J_3I",
	"_1VtblCall__II_3C",
	"_1VtblCall__II_3CIIII",
	"_1VtblCall__II_3CIJJJ",
	"_1VtblCall__II_3CI_3I",
	"_1VtblCall__II_3CJ_3J",
	"_1VtblCall__II_3C_3C",
	"_1VtblCall__II_3F",
	"_1VtblCall__II_3I",
	"_1VtblCall__II_3I_3I",
	"_1VtblCall__II_3I_3I_3I",
	"_1VtblCall__II_3I_3I_3I_3I",
	"_1VtblCall__II_3I_3I_3I_3I_3I_3I",
	"_1VtblCall__II_3I_3J",
	"_1VtblCall__II_3I_3J_3I",
	"_1VtblCall__II_3I_3J_3J",
	"_1VtblCall__II_3J",
	"_1VtblCall__II_3J_3J",
	"_1VtblCall__II_3J_3J_3J",
	"_1VtblCall__II_3J_3J_3J_3J_3J_3I",
	"_1VtblCall__II_3S",
	"_1VtblCall__II_3SI_3I_3I",
	"_1VtblCall__II_3SJ_3I_3J",
	"_1XPCOMGlueLoadXULFunctions",
	"_1XPCOMGlueShutdown",
	"_1XPCOMGlueStartup",
	"_1nsEmbedCString_1Length",
	"_1nsEmbedCString_1delete",
	"_1nsEmbedCString_1get",
	"_1nsEmbedCString_1new__",
	"_1nsEmbedCString_1new__II",
	"_1nsEmbedCString_1new___3BI",
	"_1nsEmbedString_1Length",
	"_1nsEmbedString_1delete",
	"_1nsEmbedString_1get",
	"_1nsEmbedString_1new__",
	"_1nsEmbedString_1new___3C",
	"_1nsID_1Equals",
	"_1nsID_1delete",
	"_1nsID_1new",
	"_1nsIMemory_1Alloc",
	"_1nsIMemory_1Realloc",
	"_1nsIScriptContext_1GetNativeContext",
	"_1nsIScriptGlobalObject_1EnsureScriptEnvironment",
	"_1nsIScriptGlobalObject_1GetScriptContext",
	"_1nsIScriptGlobalObject_1GetScriptGlobal",
	"memmove__ILorg_eclipse_swt_internal_mozilla_nsDynamicFunctionLoad_2I",
	"memmove__ILorg_eclipse_swt_internal_mozilla_nsID_2I",
	"memmove__Lorg_eclipse_swt_internal_mozilla_nsID_2II",
	"nsDynamicFunctionLoad_1sizeof",
	"strlen_1PRUnichar",
};

#define STATS_NATIVE(func) Java_org_eclipse_swt_tools_internal_NativeStats_##func

JNIEXPORT jint JNICALL STATS_NATIVE(XPCOM_1GetFunctionCount)
	(JNIEnv *env, jclass that)
{
	return XPCOM_nativeFunctionCount;
}

JNIEXPORT jstring JNICALL STATS_NATIVE(XPCOM_1GetFunctionName)
	(JNIEnv *env, jclass that, jint index)
{
	return env->NewStringUTF(XPCOM_nativeFunctionNames[index]);
}

JNIEXPORT jint JNICALL STATS_NATIVE(XPCOM_1GetFunctionCallCount)
	(JNIEnv *env, jclass that, jint index)
{
	return XPCOM_nativeFunctionCallCount[index];
}

#endif
