/*******************************************************************************
 * Copyright (c) 2000, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    IBM Corporation - initial API and implementation
 *******************************************************************************/

#include "swt.h"
#include "xpcom_stats.h"

#ifdef NATIVE_STATS

int XPCOM_nativeFunctionCount = 225;
int XPCOM_nativeFunctionCallCount[225];
char * XPCOM_nativeFunctionNames[] = {
	"_1Call__J",
	"_1Call__JJJJJI",
	"_1Call__JJJ_3BII_3I",
	"_1JS_1EvaluateUCScriptForPrincipals",
	"_1NS_1GetComponentManager",
	"_1NS_1GetServiceManager",
	"_1NS_1InitXPCOM2",
	"_1NS_1NewLocalFile",
	"_1VtblCall__IJ",
	"_1VtblCall__IJD",
	"_1VtblCall__IJF",
	"_1VtblCall__IJI",
	"_1VtblCall__IJII",
	"_1VtblCall__IJIII",
	"_1VtblCall__IJIIII",
	"_1VtblCall__IJIIIII",
	"_1VtblCall__IJIIIIII",
	"_1VtblCall__IJIIIIIIIIII",
	"_1VtblCall__IJIIIIIIIIIIIIISI",
	"_1VtblCall__IJIIIIIII_3I",
	"_1VtblCall__IJIIIIII_3C_3I_3I",
	"_1VtblCall__IJIIIII_3I",
	"_1VtblCall__IJIIIIJII",
	"_1VtblCall__IJIIII_3CIIIII_3I_3I",
	"_1VtblCall__IJIIII_3C_3BIIIII_3I_3I",
	"_1VtblCall__IJIIII_3C_3I_3I",
	"_1VtblCall__IJIIII_3I_3I",
	"_1VtblCall__IJIIII_3I_3I_3I",
	"_1VtblCall__IJIII_3B_3BI",
	"_1VtblCall__IJIII_3C",
	"_1VtblCall__IJIII_3I",
	"_1VtblCall__IJIII_3I_3I_3I",
	"_1VtblCall__IJIIJJJJ",
	"_1VtblCall__IJII_3B",
	"_1VtblCall__IJII_3BI",
	"_1VtblCall__IJII_3BII",
	"_1VtblCall__IJII_3B_3B",
	"_1VtblCall__IJII_3C",
	"_1VtblCall__IJII_3CIJI",
	"_1VtblCall__IJII_3CJJJ",
	"_1VtblCall__IJII_3C_3CI_3I",
	"_1VtblCall__IJII_3I",
	"_1VtblCall__IJII_3I_3I",
	"_1VtblCall__IJII_3J",
	"_1VtblCall__IJIJJ",
	"_1VtblCall__IJIJJJJJJ_3J",
	"_1VtblCall__IJILorg_eclipse_swt_internal_mozilla_nsID_2",
	"_1VtblCall__IJILorg_eclipse_swt_internal_mozilla_nsID_2II_3I",
	"_1VtblCall__IJILorg_eclipse_swt_internal_mozilla_nsID_2_3I",
	"_1VtblCall__IJI_3B",
	"_1VtblCall__IJI_3BI",
	"_1VtblCall__IJI_3BI_3I",
	"_1VtblCall__IJI_3BS",
	"_1VtblCall__IJI_3B_3B_3BI_3I",
	"_1VtblCall__IJI_3B_3C",
	"_1VtblCall__IJI_3B_3I",
	"_1VtblCall__IJI_3C",
	"_1VtblCall__IJI_3CI",
	"_1VtblCall__IJI_3C_3C",
	"_1VtblCall__IJI_3C_3CI_3C_3C_3C_3C_3I_3I",
	"_1VtblCall__IJI_3C_3CI_3I_3I_3I",
	"_1VtblCall__IJI_3C_3C_3C_3I",
	"_1VtblCall__IJI_3C_3C_3C_3I_3I",
	"_1VtblCall__IJI_3C_3C_3I",
	"_1VtblCall__IJI_3C_3C_3I_3C_3I_3I",
	"_1VtblCall__IJI_3C_3C_3I_3I_3C_3I_3I",
	"_1VtblCall__IJI_3C_3I",
	"_1VtblCall__IJI_3I",
	"_1VtblCall__IJI_3II",
	"_1VtblCall__IJI_3IJ",
	"_1VtblCall__IJI_3I_3I_3I",
	"_1VtblCall__IJI_3I_3I_3I_3I",
	"_1VtblCall__IJI_3I_3I_3J",
	"_1VtblCall__IJJ",
	"_1VtblCall__IJJI",
	"_1VtblCall__IJJIIJIIIIII",
	"_1VtblCall__IJJIIJIIIIIIIIISJ",
	"_1VtblCall__IJJIIJ_3I_3J",
	"_1VtblCall__IJJII_3I",
	"_1VtblCall__IJJIJII",
	"_1VtblCall__IJJIJJ_3I_3I_3I",
	"_1VtblCall__IJJIJ_3I_3I_3I",
	"_1VtblCall__IJJI_3J",
	"_1VtblCall__IJJJ",
	"_1VtblCall__IJJJI",
	"_1VtblCall__IJJJII",
	"_1VtblCall__IJJJIIII",
	"_1VtblCall__IJJJIJ_3C_3I_3I",
	"_1VtblCall__IJJJI_3C",
	"_1VtblCall__IJJJI_3I",
	"_1VtblCall__IJJJJ",
	"_1VtblCall__IJJJJI",
	"_1VtblCall__IJJJJI_3CJJIJI_3J_3J",
	"_1VtblCall__IJJJJI_3C_3BJJIJI_3J_3J",
	"_1VtblCall__IJJJJJIJ_3C_3I_3J",
	"_1VtblCall__IJJJJJJ",
	"_1VtblCall__IJJJJJJJ",
	"_1VtblCall__IJJJJJJJJ",
	"_1VtblCall__IJJJJJJ_3J",
	"_1VtblCall__IJJJJ_3B_3BJ",
	"_1VtblCall__IJJJJ_3I",
	"_1VtblCall__IJJJJ_3J",
	"_1VtblCall__IJJJ_3B",
	"_1VtblCall__IJJJ_3BJ",
	"_1VtblCall__IJJJ_3BJI",
	"_1VtblCall__IJJJ_3B_3B",
	"_1VtblCall__IJJJ_3CIJI",
	"_1VtblCall__IJJJ_3CJJJ",
	"_1VtblCall__IJJJ_3C_3CI_3J",
	"_1VtblCall__IJJJ_3I",
	"_1VtblCall__IJJJ_3I_3I",
	"_1VtblCall__IJJJ_3J",
	"_1VtblCall__IJJLorg_eclipse_swt_internal_mozilla_nsID_2",
	"_1VtblCall__IJJLorg_eclipse_swt_internal_mozilla_nsID_2JJ_3J",
	"_1VtblCall__IJJLorg_eclipse_swt_internal_mozilla_nsID_2_3J",
	"_1VtblCall__IJJ_3B",
	"_1VtblCall__IJJ_3BI",
	"_1VtblCall__IJJ_3BJ",
	"_1VtblCall__IJJ_3BJ_3J",
	"_1VtblCall__IJJ_3BS",
	"_1VtblCall__IJJ_3B_3B_3BJ_3J",
	"_1VtblCall__IJJ_3B_3C",
	"_1VtblCall__IJJ_3CI",
	"_1VtblCall__IJJ_3C_3C",
	"_1VtblCall__IJJ_3C_3CI_3C_3C_3C_3C_3I_3I",
	"_1VtblCall__IJJ_3C_3CI_3J_3I_3I",
	"_1VtblCall__IJJ_3C_3C_3C_3I",
	"_1VtblCall__IJJ_3C_3C_3C_3I_3I",
	"_1VtblCall__IJJ_3C_3C_3I",
	"_1VtblCall__IJJ_3C_3C_3J",
	"_1VtblCall__IJJ_3C_3C_3J_3C_3I_3I",
	"_1VtblCall__IJJ_3C_3C_3J_3J_3C_3I_3I",
	"_1VtblCall__IJJ_3C_3J",
	"_1VtblCall__IJJ_3I",
	"_1VtblCall__IJJ_3J",
	"_1VtblCall__IJLorg_eclipse_swt_internal_mozilla_nsID_2I",
	"_1VtblCall__IJLorg_eclipse_swt_internal_mozilla_nsID_2ILorg_eclipse_swt_internal_mozilla_nsID_2_3I",
	"_1VtblCall__IJLorg_eclipse_swt_internal_mozilla_nsID_2J",
	"_1VtblCall__IJLorg_eclipse_swt_internal_mozilla_nsID_2JLorg_eclipse_swt_internal_mozilla_nsID_2_3J",
	"_1VtblCall__IJLorg_eclipse_swt_internal_mozilla_nsID_2Lorg_eclipse_swt_internal_mozilla_nsID_2_3I",
	"_1VtblCall__IJLorg_eclipse_swt_internal_mozilla_nsID_2Lorg_eclipse_swt_internal_mozilla_nsID_2_3J",
	"_1VtblCall__IJLorg_eclipse_swt_internal_mozilla_nsID_2_3B_3BI",
	"_1VtblCall__IJLorg_eclipse_swt_internal_mozilla_nsID_2_3B_3BI_3B_3B",
	"_1VtblCall__IJLorg_eclipse_swt_internal_mozilla_nsID_2_3B_3BJ",
	"_1VtblCall__IJLorg_eclipse_swt_internal_mozilla_nsID_2_3B_3BJ_3B_3B",
	"_1VtblCall__IJLorg_eclipse_swt_internal_mozilla_nsID_2_3I",
	"_1VtblCall__IJLorg_eclipse_swt_internal_mozilla_nsID_2_3J",
	"_1VtblCall__IJSIII",
	"_1VtblCall__IJSJIJ",
	"_1VtblCall__IJ_3B",
	"_1VtblCall__IJ_3BI",
	"_1VtblCall__IJ_3BII_3I_3I",
	"_1VtblCall__IJ_3BIJ_3J_3I",
	"_1VtblCall__IJ_3BILorg_eclipse_swt_internal_mozilla_nsID_2_3I",
	"_1VtblCall__IJ_3BI_3I",
	"_1VtblCall__IJ_3BI_3I_3I",
	"_1VtblCall__IJ_3BI_3J_3I",
	"_1VtblCall__IJ_3BJ",
	"_1VtblCall__IJ_3BJLorg_eclipse_swt_internal_mozilla_nsID_2_3J",
	"_1VtblCall__IJ_3BJ_3I",
	"_1VtblCall__IJ_3BLorg_eclipse_swt_internal_mozilla_nsID_2I",
	"_1VtblCall__IJ_3BLorg_eclipse_swt_internal_mozilla_nsID_2J",
	"_1VtblCall__IJ_3BLorg_eclipse_swt_internal_mozilla_nsID_2_3I",
	"_1VtblCall__IJ_3BLorg_eclipse_swt_internal_mozilla_nsID_2_3J",
	"_1VtblCall__IJ_3B_3B",
	"_1VtblCall__IJ_3B_3BI",
	"_1VtblCall__IJ_3B_3B_3BII_3I",
	"_1VtblCall__IJ_3B_3B_3BII_3J",
	"_1VtblCall__IJ_3B_3B_3I",
	"_1VtblCall__IJ_3B_3B_3J",
	"_1VtblCall__IJ_3B_3I",
	"_1VtblCall__IJ_3B_3I_3I",
	"_1VtblCall__IJ_3B_3I_3J",
	"_1VtblCall__IJ_3B_3J",
	"_1VtblCall__IJ_3B_3J_3I",
	"_1VtblCall__IJ_3C",
	"_1VtblCall__IJ_3CIIII",
	"_1VtblCall__IJ_3CIJJJ",
	"_1VtblCall__IJ_3CI_3I",
	"_1VtblCall__IJ_3CJ_3J",
	"_1VtblCall__IJ_3C_3C",
	"_1VtblCall__IJ_3F",
	"_1VtblCall__IJ_3I",
	"_1VtblCall__IJ_3I_3I",
	"_1VtblCall__IJ_3I_3I_3I",
	"_1VtblCall__IJ_3I_3I_3I_3I",
	"_1VtblCall__IJ_3I_3I_3I_3I_3I_3I",
	"_1VtblCall__IJ_3I_3J",
	"_1VtblCall__IJ_3I_3J_3I",
	"_1VtblCall__IJ_3I_3J_3J",
	"_1VtblCall__IJ_3J",
	"_1VtblCall__IJ_3J_3J",
	"_1VtblCall__IJ_3J_3J_3J",
	"_1VtblCall__IJ_3J_3J_3J_3J_3J_3I",
	"_1VtblCall__IJ_3S",
	"_1VtblCall__IJ_3SI_3I_3I",
	"_1VtblCall__IJ_3SJ_3I_3J",
	"_1XPCOMGlueLoadXULFunctions",
	"_1XPCOMGlueShutdown",
	"_1XPCOMGlueStartup",
	"_1nsEmbedCString_1Length",
	"_1nsEmbedCString_1delete",
	"_1nsEmbedCString_1get",
	"_1nsEmbedCString_1new__",
	"_1nsEmbedCString_1new__JI",
	"_1nsEmbedCString_1new___3BI",
	"_1nsEmbedString_1Length",
	"_1nsEmbedString_1delete",
	"_1nsEmbedString_1get",
	"_1nsEmbedString_1new__",
	"_1nsEmbedString_1new___3C",
	"_1nsID_1Equals",
	"_1nsID_1delete",
	"_1nsID_1new",
	"_1nsIMemory_1Alloc",
	"_1nsIMemory_1Realloc",
	"_1nsIScriptContext_1GetNativeContext",
	"_1nsIScriptGlobalObject_1EnsureScriptEnvironment",
	"_1nsIScriptGlobalObject_1GetScriptContext",
	"_1nsIScriptGlobalObject_1GetScriptGlobal",
	"memmove__JLorg_eclipse_swt_internal_mozilla_nsDynamicFunctionLoad_2J",
	"memmove__JLorg_eclipse_swt_internal_mozilla_nsID_2I",
	"memmove__Lorg_eclipse_swt_internal_mozilla_nsID_2JI",
	"nsDynamicFunctionLoad_1sizeof",
	"strlen_1PRUnichar",
};

#define STATS_NATIVE(func) Java_org_eclipse_swt_tools_internal_NativeStats_##func

JNIEXPORT jint JNICALL STATS_NATIVE(XPCOM_1GetFunctionCount)
	(JNIEnv *env, jclass that)
{
	return XPCOM_nativeFunctionCount;
}

JNIEXPORT jstring JNICALL STATS_NATIVE(XPCOM_1GetFunctionName)
	(JNIEnv *env, jclass that, jint index)
{
	return env->NewStringUTF(XPCOM_nativeFunctionNames[index]);
}

JNIEXPORT jint JNICALL STATS_NATIVE(XPCOM_1GetFunctionCallCount)
	(JNIEnv *env, jclass that, jint index)
{
	return XPCOM_nativeFunctionCallCount[index];
}

#endif
