/*******************************************************************************
 * Copyright (c) 2000, 2009 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    IBM Corporation - initial API and implementation
 *******************************************************************************/

#ifdef NATIVE_STATS
extern int XPCOM_nativeFunctionCount;
extern int XPCOM_nativeFunctionCallCount[];
extern char* XPCOM_nativeFunctionNames[];
#define XPCOM_NATIVE_ENTER(env, that, func) XPCOM_nativeFunctionCallCount[func]++;
#define XPCOM_NATIVE_EXIT(env, that, func) 
#else
#ifndef XPCOM_NATIVE_ENTER
#define XPCOM_NATIVE_ENTER(env, that, func) 
#endif
#ifndef XPCOM_NATIVE_EXIT
#define XPCOM_NATIVE_EXIT(env, that, func) 
#endif
#endif

typedef enum {
	_1Call__I_FUNC,
	_1Call__IIIIII_FUNC,
	_1Call__III_3BII_3I_FUNC,
	_1JS_1EvaluateUCScriptForPrincipals_FUNC,
	_1NS_1GetComponentManager_FUNC,
	_1NS_1GetServiceManager_FUNC,
	_1NS_1InitXPCOM2_FUNC,
	_1NS_1NewLocalFile_FUNC,
	_1VtblCall__II_FUNC,
	_1VtblCall__IID_FUNC,
	_1VtblCall__IIF_FUNC,
	_1VtblCall__III_FUNC,
	_1VtblCall__IIII_FUNC,
	_1VtblCall__IIIII_FUNC,
	_1VtblCall__IIIIII_FUNC,
	_1VtblCall__IIIIIII_FUNC,
	_1VtblCall__IIIIIIII_FUNC,
	_1VtblCall__IIIIIIIIIIII_FUNC,
	_1VtblCall__IIIIIIIIIIIIIIISI_FUNC,
	_1VtblCall__IIIIIIIII_3I_FUNC,
	_1VtblCall__IIIIIIII_3C_3I_3I_FUNC,
	_1VtblCall__IIIIIII_3I_FUNC,
	_1VtblCall__IIIIIIJII_FUNC,
	_1VtblCall__IIIIII_3CIIIII_3I_3I_FUNC,
	_1VtblCall__IIIIII_3C_3BIIIII_3I_3I_FUNC,
	_1VtblCall__IIIIII_3C_3I_3I_FUNC,
	_1VtblCall__IIIIII_3I_3I_FUNC,
	_1VtblCall__IIIIII_3I_3I_3I_FUNC,
	_1VtblCall__IIIII_3B_3BI_FUNC,
	_1VtblCall__IIIII_3C_FUNC,
	_1VtblCall__IIIII_3I_FUNC,
	_1VtblCall__IIIII_3I_3I_3I_FUNC,
	_1VtblCall__IIIIJJJJ_FUNC,
	_1VtblCall__IIII_3B_FUNC,
	_1VtblCall__IIII_3BI_FUNC,
	_1VtblCall__IIII_3BII_FUNC,
	_1VtblCall__IIII_3B_3B_FUNC,
	_1VtblCall__IIII_3C_FUNC,
	_1VtblCall__IIII_3CIJI_FUNC,
	_1VtblCall__IIII_3CJJJ_FUNC,
	_1VtblCall__IIII_3C_3CI_3I_FUNC,
	_1VtblCall__IIII_3I_FUNC,
	_1VtblCall__IIII_3I_3I_FUNC,
	_1VtblCall__IIII_3J_FUNC,
	_1VtblCall__IIIJJ_FUNC,
	_1VtblCall__IIIJJJJJJ_3J_FUNC,
	_1VtblCall__IIILorg_eclipse_swt_internal_mozilla_nsID_2_FUNC,
	_1VtblCall__IIILorg_eclipse_swt_internal_mozilla_nsID_2II_3I_FUNC,
	_1VtblCall__IIILorg_eclipse_swt_internal_mozilla_nsID_2_3I_FUNC,
	_1VtblCall__III_3B_FUNC,
	_1VtblCall__III_3BI_FUNC,
	_1VtblCall__III_3BI_3I_FUNC,
	_1VtblCall__III_3BS_FUNC,
	_1VtblCall__III_3B_3B_3BI_3I_FUNC,
	_1VtblCall__III_3B_3C_FUNC,
	_1VtblCall__III_3B_3I_FUNC,
	_1VtblCall__III_3C_FUNC,
	_1VtblCall__III_3CI_FUNC,
	_1VtblCall__III_3C_3C_FUNC,
	_1VtblCall__III_3C_3CI_3C_3C_3C_3C_3I_3I_FUNC,
	_1VtblCall__III_3C_3CI_3I_3I_3I_FUNC,
	_1VtblCall__III_3C_3C_3C_3I_FUNC,
	_1VtblCall__III_3C_3C_3C_3I_3I_FUNC,
	_1VtblCall__III_3C_3C_3I_FUNC,
	_1VtblCall__III_3C_3C_3I_3C_3I_3I_FUNC,
	_1VtblCall__III_3C_3C_3I_3I_3C_3I_3I_FUNC,
	_1VtblCall__III_3C_3I_FUNC,
	_1VtblCall__III_3I_FUNC,
	_1VtblCall__III_3II_FUNC,
	_1VtblCall__III_3IJ_FUNC,
	_1VtblCall__III_3I_3I_3I_FUNC,
	_1VtblCall__III_3I_3I_3I_3I_FUNC,
	_1VtblCall__III_3I_3I_3J_FUNC,
	_1VtblCall__IIJ_FUNC,
	_1VtblCall__IIJI_FUNC,
	_1VtblCall__IIJIIJIIIIII_FUNC,
	_1VtblCall__IIJIIJIIIIIIIIISJ_FUNC,
	_1VtblCall__IIJIIJ_3I_3J_FUNC,
	_1VtblCall__IIJII_3I_FUNC,
	_1VtblCall__IIJIJII_FUNC,
	_1VtblCall__IIJIJJ_3I_3I_3I_FUNC,
	_1VtblCall__IIJIJ_3I_3I_3I_FUNC,
	_1VtblCall__IIJI_3J_FUNC,
	_1VtblCall__IIJJ_FUNC,
	_1VtblCall__IIJJI_FUNC,
	_1VtblCall__IIJJII_FUNC,
	_1VtblCall__IIJJIIII_FUNC,
	_1VtblCall__IIJJIJ_3C_3I_3I_FUNC,
	_1VtblCall__IIJJI_3C_FUNC,
	_1VtblCall__IIJJI_3I_FUNC,
	_1VtblCall__IIJJJ_FUNC,
	_1VtblCall__IIJJJI_FUNC,
	_1VtblCall__IIJJJI_3CJJIJI_3J_3J_FUNC,
	_1VtblCall__IIJJJI_3C_3BJJIJI_3J_3J_FUNC,
	_1VtblCall__IIJJJJIJ_3C_3I_3J_FUNC,
	_1VtblCall__IIJJJJJ_FUNC,
	_1VtblCall__IIJJJJJJ_FUNC,
	_1VtblCall__IIJJJJJJJ_FUNC,
	_1VtblCall__IIJJJJJ_3J_FUNC,
	_1VtblCall__IIJJJ_3B_3BJ_FUNC,
	_1VtblCall__IIJJJ_3I_FUNC,
	_1VtblCall__IIJJJ_3J_FUNC,
	_1VtblCall__IIJJ_3B_FUNC,
	_1VtblCall__IIJJ_3BJ_FUNC,
	_1VtblCall__IIJJ_3BJI_FUNC,
	_1VtblCall__IIJJ_3B_3B_FUNC,
	_1VtblCall__IIJJ_3CIJI_FUNC,
	_1VtblCall__IIJJ_3CJJJ_FUNC,
	_1VtblCall__IIJJ_3C_3CI_3J_FUNC,
	_1VtblCall__IIJJ_3I_FUNC,
	_1VtblCall__IIJJ_3I_3I_FUNC,
	_1VtblCall__IIJJ_3J_FUNC,
	_1VtblCall__IIJLorg_eclipse_swt_internal_mozilla_nsID_2_FUNC,
	_1VtblCall__IIJLorg_eclipse_swt_internal_mozilla_nsID_2JJ_3J_FUNC,
	_1VtblCall__IIJLorg_eclipse_swt_internal_mozilla_nsID_2_3J_FUNC,
	_1VtblCall__IIJ_3B_FUNC,
	_1VtblCall__IIJ_3BI_FUNC,
	_1VtblCall__IIJ_3BJ_FUNC,
	_1VtblCall__IIJ_3BJ_3J_FUNC,
	_1VtblCall__IIJ_3BS_FUNC,
	_1VtblCall__IIJ_3B_3B_3BJ_3J_FUNC,
	_1VtblCall__IIJ_3B_3C_FUNC,
	_1VtblCall__IIJ_3CI_FUNC,
	_1VtblCall__IIJ_3C_3C_FUNC,
	_1VtblCall__IIJ_3C_3CI_3C_3C_3C_3C_3I_3I_FUNC,
	_1VtblCall__IIJ_3C_3CI_3J_3I_3I_FUNC,
	_1VtblCall__IIJ_3C_3C_3C_3I_FUNC,
	_1VtblCall__IIJ_3C_3C_3C_3I_3I_FUNC,
	_1VtblCall__IIJ_3C_3C_3I_FUNC,
	_1VtblCall__IIJ_3C_3C_3J_FUNC,
	_1VtblCall__IIJ_3C_3C_3J_3C_3I_3I_FUNC,
	_1VtblCall__IIJ_3C_3C_3J_3J_3C_3I_3I_FUNC,
	_1VtblCall__IIJ_3C_3J_FUNC,
	_1VtblCall__IIJ_3I_FUNC,
	_1VtblCall__IIJ_3J_FUNC,
	_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2I_FUNC,
	_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2ILorg_eclipse_swt_internal_mozilla_nsID_2_3I_FUNC,
	_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2J_FUNC,
	_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2JLorg_eclipse_swt_internal_mozilla_nsID_2_3J_FUNC,
	_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2Lorg_eclipse_swt_internal_mozilla_nsID_2_3I_FUNC,
	_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2Lorg_eclipse_swt_internal_mozilla_nsID_2_3J_FUNC,
	_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2_3B_3BI_FUNC,
	_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2_3B_3BI_3B_3B_FUNC,
	_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2_3B_3BJ_FUNC,
	_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2_3B_3BJ_3B_3B_FUNC,
	_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2_3I_FUNC,
	_1VtblCall__IILorg_eclipse_swt_internal_mozilla_nsID_2_3J_FUNC,
	_1VtblCall__IISIII_FUNC,
	_1VtblCall__IISJIJ_FUNC,
	_1VtblCall__II_3B_FUNC,
	_1VtblCall__II_3BI_FUNC,
	_1VtblCall__II_3BII_3I_3I_FUNC,
	_1VtblCall__II_3BIJ_3J_3I_FUNC,
	_1VtblCall__II_3BILorg_eclipse_swt_internal_mozilla_nsID_2_3I_FUNC,
	_1VtblCall__II_3BI_3I_FUNC,
	_1VtblCall__II_3BI_3I_3I_FUNC,
	_1VtblCall__II_3BI_3J_3I_FUNC,
	_1VtblCall__II_3BJ_FUNC,
	_1VtblCall__II_3BJLorg_eclipse_swt_internal_mozilla_nsID_2_3J_FUNC,
	_1VtblCall__II_3BJ_3I_FUNC,
	_1VtblCall__II_3BLorg_eclipse_swt_internal_mozilla_nsID_2I_FUNC,
	_1VtblCall__II_3BLorg_eclipse_swt_internal_mozilla_nsID_2J_FUNC,
	_1VtblCall__II_3BLorg_eclipse_swt_internal_mozilla_nsID_2_3I_FUNC,
	_1VtblCall__II_3BLorg_eclipse_swt_internal_mozilla_nsID_2_3J_FUNC,
	_1VtblCall__II_3B_3B_FUNC,
	_1VtblCall__II_3B_3BI_FUNC,
	_1VtblCall__II_3B_3B_3BII_3I_FUNC,
	_1VtblCall__II_3B_3B_3BII_3J_FUNC,
	_1VtblCall__II_3B_3B_3I_FUNC,
	_1VtblCall__II_3B_3B_3J_FUNC,
	_1VtblCall__II_3B_3I_FUNC,
	_1VtblCall__II_3B_3I_3I_FUNC,
	_1VtblCall__II_3B_3I_3J_FUNC,
	_1VtblCall__II_3B_3J_FUNC,
	_1VtblCall__II_3B_3J_3I_FUNC,
	_1VtblCall__II_3C_FUNC,
	_1VtblCall__II_3CIIII_FUNC,
	_1VtblCall__II_3CIJJJ_FUNC,
	_1VtblCall__II_3CI_3I_FUNC,
	_1VtblCall__II_3CJ_3J_FUNC,
	_1VtblCall__II_3C_3C_FUNC,
	_1VtblCall__II_3F_FUNC,
	_1VtblCall__II_3I_FUNC,
	_1VtblCall__II_3I_3I_FUNC,
	_1VtblCall__II_3I_3I_3I_FUNC,
	_1VtblCall__II_3I_3I_3I_3I_FUNC,
	_1VtblCall__II_3I_3I_3I_3I_3I_3I_FUNC,
	_1VtblCall__II_3I_3J_FUNC,
	_1VtblCall__II_3I_3J_3I_FUNC,
	_1VtblCall__II_3I_3J_3J_FUNC,
	_1VtblCall__II_3J_FUNC,
	_1VtblCall__II_3J_3J_FUNC,
	_1VtblCall__II_3J_3J_3J_FUNC,
	_1VtblCall__II_3J_3J_3J_3J_3J_3I_FUNC,
	_1VtblCall__II_3S_FUNC,
	_1VtblCall__II_3SI_3I_3I_FUNC,
	_1VtblCall__II_3SJ_3I_3J_FUNC,
	_1XPCOMGlueLoadXULFunctions_FUNC,
	_1XPCOMGlueShutdown_FUNC,
	_1XPCOMGlueStartup_FUNC,
	_1nsEmbedCString_1Length_FUNC,
	_1nsEmbedCString_1delete_FUNC,
	_1nsEmbedCString_1get_FUNC,
	_1nsEmbedCString_1new___FUNC,
	_1nsEmbedCString_1new__II_FUNC,
	_1nsEmbedCString_1new___3BI_FUNC,
	_1nsEmbedString_1Length_FUNC,
	_1nsEmbedString_1delete_FUNC,
	_1nsEmbedString_1get_FUNC,
	_1nsEmbedString_1new___FUNC,
	_1nsEmbedString_1new___3C_FUNC,
	_1nsID_1Equals_FUNC,
	_1nsID_1delete_FUNC,
	_1nsID_1new_FUNC,
	_1nsIMemory_1Alloc_FUNC,
	_1nsIMemory_1Realloc_FUNC,
	_1nsIScriptContext_1GetNativeContext_FUNC,
	_1nsIScriptGlobalObject_1EnsureScriptEnvironment_FUNC,
	_1nsIScriptGlobalObject_1GetScriptContext_FUNC,
	_1nsIScriptGlobalObject_1GetScriptGlobal_FUNC,
	memmove__ILorg_eclipse_swt_internal_mozilla_nsDynamicFunctionLoad_2I_FUNC,
	memmove__ILorg_eclipse_swt_internal_mozilla_nsID_2I_FUNC,
	memmove__Lorg_eclipse_swt_internal_mozilla_nsID_2II_FUNC,
	nsDynamicFunctionLoad_1sizeof_FUNC,
	strlen_1PRUnichar_FUNC,
} XPCOM_FUNCS;
